/*
 *   dbpriv.h  - simple database engine.
 *   Private declarations.
 */

#define S 255

typedef struct {
   long int i;
   int and;		/* should values be ANDed or ORed? */
} DB_Mask;

typedef struct {
   int values[32];
   int length;
} DB_Lookup;

typedef struct {
   int m;		/* month */
   int d;		/* day */
   int y;		/* year */
   int h;		/* hour */
   int mi;		/* minute */
   int s;		/* second */
   DBCompar c;		/* comparison function */
} DB_Date;

typedef struct {
   long int i;		/* actual value */
   DBCompar c;		/* comparison function */
} DB_Number;

typedef struct {
   DBType type;		/* type of field */
   union {
      DB_Mask m;	/* mask */
      DB_Lookup l;	/* lookup */
      char s[S];	/* string */
      DB_Date d;	/* date */
      DB_Number n;	/* number */
      int b;		/* boolean */
   } v;
} DB_Field;
